diff --git a/src/MQTTAsync.c b/src/MQTTAsync.c
index 047e95b3..c762abf7 100644
--- a/src/MQTTAsync.c
+++ b/src/MQTTAsync.c
@@ -43,6 +43,8 @@
 #include <string.h>
 #if !defined(_WIN32) && !defined(_WIN64)
 	#include <sys/time.h>
+#else
+	#define snprintf _snprintf
 #endif
 
 #if !defined(NO_PERSISTENCE)
diff --git a/src/MQTTClient.c b/src/MQTTClient.c
index 4b5c1751..71b710fd 100644
--- a/src/MQTTClient.c
+++ b/src/MQTTClient.c
@@ -47,6 +47,8 @@
 #include <string.h>
 #if !defined(_WIN32) && !defined(_WIN64)
 	#include <sys/time.h>
+#else
+	#define snprintf _snprintf
 #endif
 
 #include "MQTTClient.h"
diff --git a/src/MQTTPersistence.c b/src/MQTTPersistence.c
index d8f556e7..14fd4f0d 100644
--- a/src/MQTTPersistence.c
+++ b/src/MQTTPersistence.c
@@ -31,6 +31,10 @@
 #include "MQTTProtocolClient.h"
 #include "Heap.h"
 
+#if defined(_WIN32) || defined(_WIN64)
+	#define snprintf _snprintf
+#endif
+
 
 static MQTTPersistence_qEntry* MQTTPersistence_restoreQueueEntry(char* buffer, size_t buflen, int MQTTVersion);
 static void MQTTPersistence_insertInSeqOrder(List* list, MQTTPersistence_qEntry* qEntry, size_t size);
diff --git a/src/MQTTPersistenceDefault.c b/src/MQTTPersistenceDefault.c
index a8a97ae7..2a27f805 100644
--- a/src/MQTTPersistenceDefault.c
+++ b/src/MQTTPersistenceDefault.c
@@ -40,6 +40,7 @@
 	#include <direct.h>
 	/* Windows doesn't have strtok_r, so remap it to strtok */
 	#define strtok_r( A, B, C ) strtok( A, B )
+	#define snprintf _snprintf
 	int keysWin32(char *, char ***, int *);
 	int clearWin32(char *);
 	int containskeyWin32(char *, char *);
diff --git a/src/MQTTVersion.c b/src/MQTTVersion.c
index dd8db178..92cd020c 100644
--- a/src/MQTTVersion.c
+++ b/src/MQTTVersion.c
@@ -31,6 +31,7 @@
 #include <tchar.h>
 #include <io.h>
 #include <sys/stat.h>
+#define snprintf _snprintf
 #else
 #include <dlfcn.h>
 #include <sys/mman.h>
diff --git a/src/SSLSocket.c b/src/SSLSocket.c
index f2559a3b..52bac08a 100644
--- a/src/SSLSocket.c
+++ b/src/SSLSocket.c
@@ -82,6 +82,7 @@ static int tls_ex_index_ssl_opts;
 #if defined(_WIN32) || defined(_WIN64)
 #define iov_len len
 #define iov_base buf
+#define snprintf _snprintf
 #endif
 
 /**
diff --git a/src/Socket.c b/src/Socket.c
index e4d7027c..4d4a4ab2 100644
--- a/src/Socket.c
+++ b/src/Socket.c
@@ -58,6 +58,7 @@ int Socket_abortWrite(int socket);
 #if defined(_WIN32) || defined(_WIN64)
 #define iov_len len
 #define iov_base buf
+#define snprintf _snprintf
 #endif
 
 /**
